'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = function (_ref) {
  var t = _ref.types;

  var defaultIdentifier = t.identifier('default');
  var rewireIdentifier = t.identifier('rewire');
  var stubIdentifier = t.identifier('$stub');
  var IGNORE_SYMBOL = Symbol();

  var buildStub = (0, _babelTemplate2.default)('\n    export function REWIRE(STUB) {\n      LOCAL = STUB;\n    }\n  ', { sourceType: 'module' });

  var buildRestore = (0, _babelTemplate2.default)('\n    export function restore() {\n      RESTORE\n    }\n  ', { sourceType: 'module' });

  function markIgnored(node) {
    node[IGNORE_SYMBOL] = true;
    return node;
  }

  return {
    visitor: {
      Program: {
        enter: function enter(path, state) {
          state.exports = new Map();
        },
        exit: function exit(path, _ref2) {
          var exports = _ref2.exports;

          if (!exports.size) return;
          var rewired = Array.from(exports.entries()).map(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2);

            var exported = _ref4[0];
            var local = _ref4[1];
            return {
              exported: exported,
              local: local,
              temp: path.scope.generateUidIdentifierBasedOnNode(exported)
            };
          });
          var vars = rewired.map(function (_ref5) {
            var local = _ref5.local;
            var temp = _ref5.temp;
            return t.variableDeclarator(temp, local);
          });
          var stubs = rewired.map(function (_ref6) {
            var exported = _ref6.exported;
            var local = _ref6.local;
            return markIgnored(buildStub({
              REWIRE: t.isIdentifier(exported, defaultIdentifier) ? rewireIdentifier : t.identifier('rewire$' + exported.name),
              LOCAL: local,
              STUB: stubIdentifier
            }));
          });
          var assignments = rewired.map(function (_ref7) {
            var local = _ref7.local;
            var temp = _ref7.temp;
            return t.expressionStatement(t.assignmentExpression('=', local, temp));
          });
          path.pushContainer('body', [t.variableDeclaration('var', vars)].concat(_toConsumableArray(stubs), [markIgnored(buildRestore({ RESTORE: assignments }))]));
        }
      },
      // export default
      ExportDefaultDeclaration: function ExportDefaultDeclaration(path, _ref8) {
        var exports = _ref8.exports;

        var declaration = path.node.declaration;
        if (t.isIdentifier(declaration)) {
          // export default foo
          exports.set(defaultIdentifier, declaration);
          path.replaceWith(markIgnored(t.exportNamedDeclaration(null, [t.exportSpecifier(declaration, defaultIdentifier)])));
        } else if (t.isFunctionDeclaration(declaration)) {
          //export default function () {}
          var id = declaration.id || path.scope.generateUidIdentifier('default');
          exports.set(defaultIdentifier, id);
          path.replaceWithMultiple([t.variableDeclaration('var', [t.variableDeclarator(id, t.functionExpression(declaration.id, declaration.params, declaration.body, declaration.generator, declaration.async))]), markIgnored(t.exportNamedDeclaration(null, [t.exportSpecifier(id, defaultIdentifier)]))]);
        } else if (t.isClassDeclaration(declaration)) {
          //export default class {}
          var _id = declaration.id || path.scope.generateUidIdentifier('default');
          exports.set(defaultIdentifier, _id);
          path.replaceWithMultiple([t.variableDeclaration('var', [t.variableDeclarator(_id, t.classExpression(declaration.id, declaration.superClass, declaration.body, declaration.decorators || []))]), markIgnored(t.exportNamedDeclaration(null, [t.exportSpecifier(_id, defaultIdentifier)]))]);
        } else {
          // export default ...
          var _id2 = path.scope.generateUidIdentifier('default');
          exports.set(defaultIdentifier, _id2);
          path.replaceWithMultiple([t.variableDeclaration('var', [t.variableDeclarator(_id2, declaration)]), markIgnored(t.exportNamedDeclaration(null, [t.exportSpecifier(_id2, defaultIdentifier)]))]);
        }
      },
      // export {}
      ExportNamedDeclaration: function ExportNamedDeclaration(path, _ref9) {
        var exports = _ref9.exports;

        if (path.node[IGNORE_SYMBOL]) return;
        // export { foo } from './bar.js'
        if (path.node.source) return;

        var declaration = path.node.declaration;
        if (t.isVariableDeclaration(declaration)) {
          // export const foo = 'bar'
          if (declaration.kind === 'const') return;
          // export var foo
          declaration.declarations.forEach(function (_ref10) {
            var id = _ref10.id;

            exports.set(id, id);
          });
        } else if (t.isFunctionDeclaration(declaration)) {
          // export function foo() {}
          var id = declaration.id;
          exports.set(id, id);
          path.replaceWithMultiple([t.variableDeclaration('var', [t.variableDeclarator(id, t.functionExpression(id, declaration.params, declaration.body, declaration.generator, declaration.async))]), markIgnored(t.exportNamedDeclaration(null, [t.exportSpecifier(id, id)]))]);
        } else if (t.isClassDeclaration(declaration)) {
          // export function class foo {}
          var _id3 = declaration.id;
          exports.set(_id3, _id3);
          path.replaceWithMultiple([t.variableDeclaration('var', [t.variableDeclarator(_id3, t.classExpression(_id3, declaration.superClass, declaration.body, declaration.decorators || []))]), markIgnored(t.exportNamedDeclaration(null, [t.exportSpecifier(_id3, _id3)]))]);
        } else {
          // export {foo}
          path.node.specifiers.forEach(function (_ref11) {
            var exported = _ref11.exported;
            var local = _ref11.local;

            exports.set(exported, local);
          });
        }
      }
    }
  };
};

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }